[ACM] HDU 4035 Maze (概率DP,转化方程)

来源:互联网 发布:数据库ip地址查询器 编辑:程序博客网 时间:2024/06/05 01:01

Maze

Special Judge

Problem Description
When wake up, lxhgww find himself in a huge maze.

The maze consisted by N rooms and tunnels connecting these rooms. Each pair of rooms is connected by one and only one path. Initially, lxhgww is in room 1. Each room has a dangerous trap. When lxhgww step into a room, he has a possibility to be killed and restart from room 1. Every room also has a hidden exit. Each time lxhgww comes to a room, he has chance to find the exit and escape from this maze.

Unfortunately, lxhgww has no idea about the structure of the whole maze. Therefore, he just chooses a tunnel randomly each time. When he is in a room, he has the same possibility to choose any tunnel connecting that room (including the tunnel he used to come to that room).
What is the expect number of tunnels he go through before he find the exit?
 

Input
First line is an integer T (T ≤ 30), the number of test cases.

At the beginning of each case is an integer N (2 ≤ N ≤ 10000), indicates the number of rooms in this case.

Then N-1 pairs of integers X, Y (1 ≤ X, Y ≤ N, X ≠ Y) are given, indicate there is a tunnel between room X and room Y.

Finally, N pairs of integers Ki and Ei (0 ≤ Ki, Ei ≤ 100, Ki + Ei ≤ 100, K1 = E1 = 0) are given, indicate the percent of the possibility of been killed and exit in the ith room.
 

Output
For each test case, output one line “Case k: ”. k is the case id, then the expect number of tunnels lxhgww go through before he exit. The answer with relative error less than 0.0001 will get accepted. If it is not possible to escape from the maze, output “impossible”.
 

Sample Input
331 21 30 0100 00 10031 22 30 0100 00 10061 22 31 44 54 60 020 3040 3050 5070 1020 60
 

Sample Output
Case 1: 2.000000Case 2: impossibleCase 3: 2.895522
 

Source
The 36th ACM/ICPC Asia Regional Chengdu Site —— Online Contest


网络赛的一道题目,这道题就是ZOJ 3329 的升级版.   http://blog.csdn.net/sr_19930829/article/details/38322163

那个还能看懂并能自己写出代码,那么这个真的无语了,数学不好真的做不出来.......不过学到这种思想就很好了!

看了解题报告,转载于:http://blog.csdn.net/morgan_xww/article/details/6776947


题意: 
    有n个房间,由n-1条隧道连通起来,实际上就形成了一棵树, 
    从结点1出发,开始走,在每个结点i都有3种可能: 
        1.被杀死,回到结点1处(概率为ki) 
        2.找到出口,走出迷宫 (概率为ei) 
        3.和该点相连有m条边,随机走一条 
    求:走出迷宫所要走的边数的期望值。 
     
    设 E[i]表示在结点i处,要走出迷宫所要走的边数的期望。E[1]即为所求。 
     
    叶子结点: 
    E[i] = ki*E[1] + ei*0 + (1-ki-ei)*(E[father[i]] + 1); 
         = ki*E[1] + (1-ki-ei)*E[father[i]] + (1-ki-ei); 
     
    非叶子结点:(m为与结点相连的边数) 
    E[i] = ki*E[1] + ei*0 + (1-ki-ei)/m*( E[father[i]]+1 + ∑( E[child[i]]+1 ) ); 
         = ki*E[1] + (1-ki-ei)/m*E[father[i]] + (1-ki-ei)/m*∑(E[child[i]]) + (1-ki-ei); 
     
    设对每个结点:E[i] = Ai*E[1] + Bi*E[father[i]] + Ci; 
     
    对于非叶子结点i,设j为i的孩子结点,则 
    ∑(E[child[i]]) = ∑E[j] 
                   = ∑(Aj*E[1] + Bj*E[father[j]] + Cj) 
                   = ∑(Aj*E[1] + Bj*E[i] + Cj) 
    带入上面的式子得 
    (1 - (1-ki-ei)/m*∑Bj)*E[i] = (ki+(1-ki-ei)/m*∑Aj)*E[1] + (1-ki-ei)/m*E[father[i]] + 


(1-ki-ei) + (1-ki-ei)/m*∑Cj; 
    由此可得 
    Ai =        (ki+(1-ki-ei)/m*∑Aj)   / (1 - (1-ki-ei)/m*∑Bj); 
    Bi =        (1-ki-ei)/m            / (1 - (1-ki-ei)/m*∑Bj); 
    Ci = ( (1-ki-ei)+(1-ki-ei)/m*∑Cj ) / (1 - (1-ki-ei)/m*∑Bj); 
     
    对于叶子结点 
    Ai = ki; 
    Bi = 1 - ki - ei; 
    Ci = 1 - ki - ei; 
     
    从叶子结点开始,直到算出 A1,B1,C1; 
     
    E[1] = A1*E[1] + B1*0 + C1; 
    所以 
    E[1] = C1 / (1 - A1); 
    若 A1趋近于1则无解... 

和ZOJ上的那道题一样,都得转化,找到递推式公有的部分,然后用别的系数来代替公有部分前面的东西,也就是找一个新的方程来代替所有的递推式(有的递推式不只是一个)... 所以就涉及到了方程式回带并且化简......这是一个艰巨的任务啊,,,数学不好再加上如果没有耐心,肯定悲剧...而且本题的方程回带化简是属于那种特别复杂的那种......

在这里说一下我对这类题的想法吧:

一般概率DP的题目如果构成无环有向图,那么递推就可以解决问题,而且往往都是从后往前递推,dp[i]代表当前状态要想达到目标状态,还需要的期望数。 考虑当前状态能转移到哪里去,把这些情况加起来,每个式子为 dp[i]=  sigma【  转移到下个状态的概率 *  (下个状态的已知期望+1)】,1 是不确定的,根据题目来,如果走一步就加1,如果消耗两个魔法值,就+2.

一般代码中都写成  E1=(1/3)*E1+(1/3)*E2+(1/3)*E3+1的形式

其实就是上面公式中化简后的 E1=(1/3)*(E1+1)+(1/3)*(E2+1)+(1/3)*(E3+1)

如果是有环,那么就不能单纯的递推了..,得考虑转化一下,找到递推式中不变的部分(也可以理解为常数),然后把那些可变的部分用其他简单的式子来代替,进行回带...

这样就可以找到另外的递推公式...  本题和ZOJ 上的那道题都是这种情况...关键还是找到递推式。


贴一下别人的代码把,留着学习....

#include <cstdio>  #include <iostream>  #include <vector>  #include <cmath>    using namespace std;    const int MAXN = 10000 + 5;    double e[MAXN], k[MAXN];  double A[MAXN], B[MAXN], C[MAXN];    vector<int> v[MAXN];    bool search(int i, int fa)  {      if ( v[i].size() == 1 && fa != -1 )      {          A[i] = k[i];          B[i] = 1 - k[i] - e[i];          C[i] = 1 - k[i] - e[i];          return true;      }        A[i] = k[i];      B[i] = (1 - k[i] - e[i]) / v[i].size();      C[i] = 1 - k[i] - e[i];      double tmp = 0;            for (int j = 0; j < (int)v[i].size(); j++)      {          if ( v[i][j] == fa ) continue;          if ( !search(v[i][j], i) ) return false;          A[i] += A[v[i][j]] * B[i];          C[i] += C[v[i][j]] * B[i];          tmp  += B[v[i][j]] * B[i];      }      if ( fabs(tmp - 1) < 1e-10 ) return false;      A[i] /= 1 - tmp;      B[i] /= 1 - tmp;      C[i] /= 1 - tmp;      return true;  }    int main()  {      int nc, n, s, t;        cin >> nc;      for (int ca = 1; ca <= nc; ca++)      {          cin >> n;          for (int i = 1; i <= n; i++)              v[i].clear();            for (int i = 1; i < n; i++)          {              cin >> s >> t;              v[s].push_back(t);              v[t].push_back(s);          }          for (int i = 1; i <= n; i++)          {              cin >> k[i] >> e[i];              k[i] /= 100.0;              e[i] /= 100.0;          }                    cout << "Case " << ca << ": ";          if ( search(1, -1) && fabs(1 - A[1]) > 1e-10 )              cout << C[1]/(1 - A[1]) << endl;          else              cout << "impossible" << endl;      }      return 0;  }  



0 0
原创粉丝点击